(* $Id: printer.mli,v 1.2 2012/05/22 14:29:48 fclement Exp $ *)

type file_printer = printer_phrase list

and printer_phrase =
  | Printer_def of printer_def list
  | Printer_comment of string

and printer_def =
 (Og_types.type_name * printer_name) * poly_printer_arguments * printer_kind

and printer_name = string

and poly_printer_arguments = string list

and printer_kind =
  | Record_printer of record_printer_clause
  | Sum_printer of sum_printer_clauses
  | Expr_printer of expr_printer_clause

and record_printer_clause = record_printer_field list

and record_printer_field =
  | Printer_field of record_label * expr_printer_clause

and record_label = string

and sum_printer_clauses = sum_printer_clause list

and sum_printer_clause =
  | Printer_sum_tag of sum_label
  | Printer_sum_inj of sum_label * expr_printer_clause

and sum_label = string

and expr_printer_clause =
  | Abs_printer of pattern * printer_expr

and pattern =
  | Pvariable of string * Og_types.type_expr
  | Ptuple of pattern array * Og_types.type_expr

and printer_fun_name =
    (* Argument of a functional printer *)
  | Var_printer of string
    (* Named printer *)
  | Named_printer of string

and printer_fun =
  | Const_printer of printer_fun_name
  | Fun_printer of printer_fun_name * printer_fun list
    (* First class tuple printers *)
  | Tuple_printer of expr_printer_clause

and printer_expr =
  | Const_expr of printer_fun
    (* Printer application *)
  | Apply_expr of printer_fun * pattern list
    (* Tuples printing *)
  | Tuple_expr of printer_expr array
;;
